/* ***** BEGIN LICENSE BLOCK *****
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the NPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the NPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//
//	PhoneDialer: Whlen von Telefonnummern per Hayes-Modem
//
//		(c) B.Eckstein, be@epost.de, 2003
//
//  ---------------------------------------------------------------------
//
//	+ Handler zum Klick auf Anchor mit wtai://wp/mc;\s+0241470510 
//	+ Handler zum Klick auf Anchor mit tel: nach RFC2806
//	+ Handler fuer Kommandozeilenoption "-dizzy"
//	+ Drag and Drop einer Selection ueber den Dail-Button
//	+ alle Strings nach locale
//	+ about:dizzy
//	+ Tool zum Konvertieren von html-Phonebooks in bookmarks
//	+ Tool zum erzeugen einer RDF-Datei e164-Countrycodes
//	+ Support fuer Nebenstellenanlagen und Ortswahl/Fernwahl
// 	+ Dialcommand und Devicewahl in die Preferences mit overlay
//	+ xpi erzeugen
//	+ Sinnvolles Nutzen/Aufrumen des Menubar "File" und "Edit"
//	+ dtmf-Toene ausgeben
//	+ Dial einer Selection per Contextmenu
//	+ Kommandozeile um Uebergabe einer Nummer erweitern
//	+ dtmf-sounds korrekt ablaengen und passende Pausen.
//	+ parseCmd() damit es auch unter Linux/Unix funktioniert
//	+ Feinschliff unter Linux und OpenVMS
//	+ Andere Fenster (Navigator, Addressbook) koennen ueber
//	  das Window-Menue nicht geoeffnet werden.
//	+ '-XXX' in pref-Nummernanzeige, wenn Anlage vorhanden
//	+ fax- and modem-URIs
//	+ url: in Selection und Cmdline
//	+ '.' als gltiger Trenner in Selection, alle Trenner prfen
//	+ Kontextmenue nur enabled, wenn Nummer selektiert, zeigt Nummer an.
//	+ jslib entfernt, eigene mLib aufgebaut
//	+ Kontextmenue auch im Messagepane
//
//	O Testen.
//	o Anpassungen an Firebird und Thunderbird
//	Alle:	- File/Datei-Menu unsauber, funktioniert nicht richtig
//	Mozi:	2 Menueintraege: in "Tools" (wg. Fb/Tb) und in "Window"
//	Tbird:	neue Preferences und dizzy.xul fehlt was
//	Fbird:	neue Preferences, sonst ok
//	==> ggf. Aufteilung in eigene Overlays fr Moz, Tbird und Fbird?
//		
//	o History im Profileverzeichnis des aktuellen Users ablegen
//	o tel/fax/modem-subs: POSTD ISUB TSUB REC TYPE
//	- modem-subs: MODEM DATA PARITY STOP VENDOR TYPE
//	- Adressbuchpatch fest einbauen
//	- Eintrag Kontextmenue fuer dtmf
//	- js-interne Texte als stringBundles in locale/properties-files
//	- Toolbar: [number-to-enter] [dtmf] [dial]
//	- Import per Fileselector aus einer XML-Datei direkt in die bookmarks
//	- Beim expliziten Besttigen (dialack) kein confirm(), sondern nur
//	  Nummer in Dizzy-Window anzeigen -> User muss selber klicken
//	- Hangup-Button -> +++[1sec]ath[crlf]
//	- Nummernparser: 1. Trenner Land/Ort, 2. Trenner Ort/Anschluss
//	  3. Trenner Anschluss/AuWa. Trenner koennen sein "().-"
//	- persistente LRU-Dialhistory. Laenge in prefs einstellbar
//	- Verfeinerte cmd-Generierung fuer VMS, OS2, MAC, SUN
//	- Bug in der cc-Liste beim Anzeigen in den Preferences
//	- Online-Hilfe
//



// und nachfolgendes fuer die LRU-Liste
//
var RDFC = Components.classes["@mozilla.org/rdf/container;1"].createInstance();
RDFC = RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);

var RDFCUtils = Components.classes['@mozilla.org/rdf/container-utils;1'].getService();
RDFCUtils = RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);

var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService();
RDF = RDF.QueryInterface(Components.interfaces.nsIRDFService);

var gDataSource;
var gDizzySound = new Array;

gDizzySound['0'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms0.wav" );
gDizzySound['1'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms1.wav" );
gDizzySound['2'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms2.wav" );
gDizzySound['3'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms3.wav" );
gDizzySound['4'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms4.wav" );
gDizzySound['5'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms5.wav" );
gDizzySound['6'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms6.wav" );
gDizzySound['7'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms7.wav" );
gDizzySound['8'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms8.wav" );
gDizzySound['9'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100ms9.wav" );
gDizzySound['a'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100msA.wav" );
gDizzySound['b'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100msB.wav" );
gDizzySound['c'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100msC.wav" );
gDizzySound['d'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100msD.wav" );
gDizzySound['*'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100msS.wav" );
gDizzySound['#'] = new Sound( "chrome://dizzy/content/dtmf/dtmf100msH.wav" );



//////////////////////////////////////////////////////////////////////////////
//
//	called Entry-functions
//
//////////////////////////////////////////////////////////////////////////////

	// onloadDizzy() wird ausgefuehrt, wenn das Dialer-Fenster geladen wird
	//
function onloadDizzy( )
	{
	RecentListInit( );

	if( "arguments" in window && 0 in window.arguments &&
		typeof window.arguments[0] == "string" )
			gotoTelURL( window.arguments[0] );	// cmdLine-Argument

	if( "arguments" in window && 0 in window.arguments &&
		typeof window.arguments[0] == "object" )
		{
		var ref = "";	// referrer, actual _content.location
		if( window.arguments[0].ref ) ref = window.arguments[0].ref;

		if( window.arguments[0].url )
			gotoTelURL( window.arguments[0].url, ref );
		}
	return true;
	}


	// onunloadDizzy() wird ausgefhrt, wenn das Dialer-Fenster geschlossen wird
	//
function onunloadDizzy( )
	{
	return true;
	}


function gotoTelURL( url, ref )	// tel: fax: modem: wtai://wp/mc URLs or text
	{
	url = url.replace( /^\s+/, "" );	// kann bei copypaste entstehen.

	// noch verteilen auf tel: fax: modem: nur dort, wo gueltig ist.
	postd	= url.match( /postd=([\d\-\.\(\)\*\#ABCDpw]+)/ );
	isub	= url.match( /isub=([\d\-\.\(\)]+)/ );
	tsub	= url.match( /tsub=([\d\-\.\(\)]+)/ );
	type	= url.match( /type=([^;]+)/ );
	rec	= url.match( /rec=([^;]+)/ );

//	/rec=|type=(V21|V22|vnd.[^\.]+\.[^\?]+)\??([78]?)([neoms]?)([12]?)/
//	modem   = $1
//	data	= $2	default 8
//	parity	= $3	default n
//	stop	= $4	default 1

//	alert( isub[1] +"\n"+ type[1] );

	var exp = /^tel:[\/ \+\(\)\-\.\d]+/;
	if( exp.test( url ) ) return dialNumber( url );

	var exp = /^wtai:\/\/wp\/mc;[ \+\(\)\-\.\d]+/;
	if( exp.test( url ) ) return dialNumber( url );

	var exp = /^fax:[\/ \+\(\)\-\.\d]+/;
	if( exp.test( url ) ) return dialNumber( url, "cmd.prg.fax", "cmd.par.fax" );

	var exp = /^modem:[\/ \+\(\)\-\.\d]+/;
	if( exp.test( url ) ) return dialNumber( url, "cmd.prg.modem", "cmd.par.modem" );

	var exp = /^[ \+\(\)\-\.\d]+$/;
	if( exp.test( url ) ) return dialNumber( url );

	if( url.length > 0 )
		alert( '"' + url + '" is no valid phone-uri or number.' );
	}



// Drag and Drop Text to the dial-button
//
var dialObserver =
	{
	onDrop: function( event, transferData, session )
		{
		var erg = transferData.data.replace( /\s/g, "" );
		if( erg != "" ) gotoTelURL( erg );
		},

	onDragOver: function( event, flavour, session )
		{ },

	getSupportedFlavours: function( )
		{
		var flavours = new FlavourSet( );
	//	flavours.appendFlavour( "application/x-moz-url" );
		flavours.appendFlavour( "text/unicode" );
		return flavours;
		}
	};


function fileOpenDialer()
	{
	alert( "File open clicked" );
	}

function fileSaveDialer()
	{
	alert( "File Save clicked" );
	}

function fileNewDialer()
	{
	alert( "File New clicked" );
	}

function fileExitDialer()
	{
	window.close();		// loest onunloadDialer() aus
	}



//////////////////////////////////////////////////////////////////////////////
//
//	Logic-functions
//
//////////////////////////////////////////////////////////////////////////////


function clearDisplay( )
	{
	document.getElementById( "display" ).value = "";
	}


function displayDizzyVersion()
	{
	window.openDialog( getBrowserURL(), "_blank",
		'chrome,resizable,extrachrome',
		'chrome://dizzy/content/about.xul' );
	}


function globalizeNumber( value )
	{
	value = decodeURI( value );

	//  wenn mit '+' beginnt: 1.Trenner wird '(', 2.Trenner wird ')'
	if( value[0] == '+' )
		{
		value = value.replace( /[\.(]/, '(' );
		value = value.replace( /[\.)]/, ')' );
		}

	// alle sonstigen Trenner raus
	value = value.replace( /\s+/g, "" );
	value = value.replace( /\.+/g, "" );
	value = value.replace( /\-+/g, "" );

	var prefAmtsKennziffer = mLibGetCharPref( "pbx.exchange", "0"   );
	var prefStellenintern  = [];

	for( i=0; i<10; i++ )
		prefStellenintern[i] = mLibGetIntPref( "pbx.grouplen."+i, "1" );

	if( value.length != prefStellenintern[value[0]] )
		{
		if( (value[0] >= 0) && (value[0] <= 9) )
			value = prefAmtsKennziffer + value;
		}

	return value;
	}


	// eine Telefonnummer nach RFC2806 wird an die lokalen
	// Gegebenheiten (Amtsholung, NSt, etc.) angepasst
	// ACHTUNG: Kann nicht alles nach RFC2806
	//
function localizeNumber( value )
	{
	var prefVorwahlFernamt	= mLibGetCharPref( "loc.trunkprefix", '' );
	var prefVorwahlIntlamt	= mLibGetCharPref( "loc.intl_prefix", '' );
	var prefLandesKennzahl	= mLibGetCharPref( "loc.countrycode", '' );
	var prefVorwahl		= mLibGetCharPref( "loc.areacode",    '' );
	var prefSubscriber      = mLibGetCharPref( "loc.subscriber",  '' );
	var prefHavePBX         = mLibGetBoolPref( "flag.havepbx", false );
	var prefAmtsKennziffer  = mLibGetCharPref( "pbx.exchange",    '' );

	if( value[0] == '+' )
		{
		var nr = /\+(\d+)\((\d+)\)(\d+)/;
		nr.exec( value );
		var cc = RegExp.$1;
		var ac = RegExp.$2;
		var lo = RegExp.$3;

		value = prefHavePBX ? prefAmtsKennziffer : "";

		if( cc == prefLandesKennzahl )
			{
			if( ac == prefVorwahl )
				{
				if( lo.indexOf( prefSubscriber ) == 0 )
					{
					var pLen = prefSubscriber.length;
					value = lo.substring( pLen, lo.length );
					}
				else
					{
					value += lo;
					}
				}
			else
				{
				value += prefVorwahlFernamt + ac + lo;
				}
			}
		else
			{
			value += prefVorwahlIntlamt + cc + ac + lo;
			}
		}
	else
		{
		var nr = /^\(?(\d+)[). ](.+)[-. ](\d+)$/;

		nr.exec( value );
		var cc = RegExp.$1;
		var ac = RegExp.$2;
		var lo = RegExp.$3;

	//	alert( "cc="+cc+" ac="+ac+" lo="+lo );
		}

	return value;
	}



	//	Die Nummer im Display oder Link wird gewaehlt
	//
function dialNumber( number, prg, par )
	{
	if( !prg ) prg = "cmd.prg";	// defaults, falls keine pref-namen
	if( !par ) par = "cmd.par";	// uebergeben werden

	var display = document.getElementById( "display" );

	var value = display.value;
	var label = display.value;

	if( number )
		{
		number = number.replace( /tel:/, "" );
		number = number.replace( /wtai:\/\/wp\/mc;/, "" );
		number = number.replace( /fax:/, "" );
		number = number.replace( /modem:/, "" );
		number = number.replace( /\//g, "" );

		value = number;
		label = number;
		}
	else
		{
		if( display.selectedItem )
			{
			label = display.selectedItem.getAttribute( "label" );
			value = display.selectedItem.getAttribute( "value" );
			}
		}


	var tosave = globalizeNumber( value );
	value = localizeNumber( tosave );

	if( mLibGetBoolPref( "flag.dialack", true ) )
		{
		if( confirm( 'Dialing ' + value ) == false ) return;
		}

	prg = mLibGetCharPref( prg, "" );	// passendes Programm und Parameter
	par = mLibGetCharPref( par, "" );	// aus den preferences auslesen

	par = par.replace( /\$DIENUMMER/, value );	// und die Schablone
	par = par.replace( /\$THENUMBER/, value );	// befuellen

	var rv = runProgram( prg, parseCmd( par ) )	// und ab die Post...

	if( mLibGetBoolPref( "flag.dtmfon", true ) ) dialDtmf( number );

	RecentListAddItem( label, tosave );
	}


	//	Die Nummer im Display wird gepiept
	//
function dialDtmf( number )
	{
	var display = document.getElementById( "display" );

	var value = display.value;
	var label = display.value;

	if( number )
		{
		value = number;
		label = number;
		}
	else
		{
		if (display.selectedItem )
			{
			label = display.selectedItem.getAttribute( "label" );
			value = display.selectedItem.getAttribute( "value" );
			}
		}

	if( !mLibGetBoolPref( "flag.dtmfpure", true ) )
		value = localizeNumber( globalizeNumber( value ) );

	window.setTimeout('playNextSound("'+value.toLowerCase()+'",0)',150);
	}


function playNextSound( value, index )
	{
	// nur geladene sounds abspielen, nicht definierte sounds
	// hinterlassen nur eine Pause
	//
	try	 { gDizzySound[value[index]].play(); }
	catch(e) { }

	if( value.length > ++index )
		window.setTimeout('playNextSound("'+value+'",'+index+')',150);
	}



//////////////////////////////////////////////////////////////////////////////
//
//	Recent List
//
//////////////////////////////////////////////////////////////////////////////

function RecentListInit( )
	{
	var recentlist = document.getElementById( "display" );
//	recentlist.builder.rebuild();

	var sources  = recentlist.database.GetDataSources();
	var rootnode = RDF.GetResource( recentlist.ref );

	while( sources.hasMoreElements() )
		{
		try
			{
			gDataSource = sources.getNext();
			gDataSource = gDataSource.QueryInterface(
				Components.interfaces.nsIRDFDataSource );
 	
			RDFC.Init( gDataSource, rootnode );
			}
		catch( e )
			{
			RDFCUtils.MakeSeq( gDataSource, rootnode );
			RDFC.Init( gDataSource, rootnode );
			}
		}
	}


function RecentListAddItem( label, value )
	{
	var display = document.getElementById( "display" );

	var index = value.replace( /[\+\-\(\)\.]/g, "" );

//	var newvalue = RDF.GetLiteral( value );
//	var newlabel = RDF.GetLiteral( label );
//	var newindex = RDF.GetLiteral( index );
//
//	var valueprop= RDF.GetResource( "http://www.example.com/recent#Value" );
//	var labelprop= RDF.GetResource( "http://www.example.com/recent#Label" );
//	var indexprop= RDF.GetResource( "http://www.example.com/recent#Index" );
//
//
//	var elList = RDFC.GetElements();
//	var lruLen = mLibGetIntPref( "lru.length", 8 );
//	var dspIdx = 0;
//	while( elList.hasMoreElements() )
//		{
//		var el = elList.getNext( );
//
//		// wenn Nr schon vorhanden oder ausserhalb der Liste,
//		// alten Eintrag loeschen
//		if( gDataSource.HasAssertion(el, indexprop, newindex, true) ||
//		(dspIdx++ > lruLen) )  
//			{
//			RDFC.RemoveElement( el, true );
//			display.removeItemAt( dspIdx );
//			}
//		}
//
//	// neue Nr (wieder) eintragen, jetzt an erster Stelle
//	//
//	var el = RDF.GetResource( "urn:dizzy:recent:" + index );
//	gDataSource.Assert( el, valueprop, newvalue, true );
//	gDataSource.Assert( el, labelprop, newlabel, true );
//	gDataSource.Assert( el, indexprop, newindex, true );
//	RDFC.InsertElementAt( el, 1, true );

	display.insertItemAt( 0, label, value );
	display.value = value;

//	gDataSource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
	} 


function RecentListClear( )	// removes all elements from the list.
	{
	var elList = RDFC.GetElements();
	var display = document.getElementById( "display" );

	while( elList.hasMoreElements() )
		{
		RDFC.RemoveElement( elList.getNext( ), true );
		display.removeItemAt( 0 );
		}

	gDataSource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
	}
